// SubPixelLine.cpp : Defines the entry point for the application.
//

#include <windows.h>
#include <math.h>															// sin()
#include "resource.h"

#define MAX_LOADSTRING 100

// Global Variables:
HINSTANCE hInst;								// current instance
TCHAR szTitle[MAX_LOADSTRING];								// The title bar text
TCHAR szWindowClass[MAX_LOADSTRING];								// The title bar text

// Foward declarations of functions included in this code module:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);















#define MAX(a,b)	(((a)<(b))?(b):(a))

#define ABS(a)		(((a)<0)?(-(a)):(a))

double bound_in( double a, double stop1, double stop2 )
{
	if(stop1<stop2)
	{
		if(a<stop1)a=stop1;
		if(a>stop2)a=stop2;
	}
	else
	{
		if(a>stop1)a=stop1;
		if(a<stop2)a=stop2;
	}

	return(a);
}


void LinX( HDC inHdc, int x1, int x2, int y )
{
	if(x1>x2){ int h=x1; x1=x2; x2=h; }

//	for(int x=x1;x<x2;x++)
//		SetPixel(inHdc,x,y,0x000000);

	MoveToEx(inHdc,x1,y,0);LineTo(inHdc,x2,y);
}

void LinY( HDC inHdc, int y1, int y2, int x )
{
	if(y1>y2){ int h=y1; y1=y2; y2=h; }

//	for(int y=y1;y<y2;y++)
//		SetPixel(inHdc,x,y,0x000000);

	MoveToEx(inHdc,x,y1,0);LineTo(inHdc,x,y2);
}


// BUG: lines within a pixel are not plotted
void SubPixelLine( HDC inHdc, float xa, float ya, float xe, float ye )
{
	xa+=0.5f;ya+=0.5f;xe+=0.5f;ye+=0.5f;
/*
	HPEN hpen,hpenOld;	hpen = CreatePen(PS_SOLID, 1, RGB(0, 255, 0)); hpenOld = (HPEN)SelectObject(inHdc, hpen);

				MoveToEx(inHdc,(int)xa,(int)ya,0);LineTo(inHdc,(int)xe,(int)ye);

    SelectObject(inHdc,hpenOld);DeleteObject(hpen);
*/

	double dx=xe-xa;

	if(dx<0)	// Swap
	{
		float h;
		
		h=xa;xa=xe;xe=h;
		h=ya;ya=ye;ye=h;
		dx=-dx;
	}



	double dy=ye-ya;

	if(ABS(dx)>ABS(dy))			// horizontal
	{
		double y1,y2,x1,x2;

		if(ya<ye)
			{ y1=ceil(ya);y2=floor(ye);	}
		  else
			{ y1=floor(ya);y2=ceil(ye); }

		if(ABS(dy)>0.0000001)
		{
			double m=dx/dy;

			x1=xa+m*(y1-ya);
			x2=xa+m*(y2-ya);

			if(x1>xe)x1=xe;
			if(x2<xa)x2=xa;
		}
		else { x1=xe;x2=xa; }

		double from=x1;
		double step=(x2-from)/(y2-y1);

		if(ya<ye)
		{
			for(int y=(int)y1;y<(int)y2;y++,from+=step)
				LinX(inHdc,(int)from,(int)(from+step),(int)y);
		}
		else
		{
			for(int y=(int)y1-1;y>=(int)y2;y--,from-=step)
				LinX(inHdc,(int)from,(int)(from-step),(int)y);
		}

		LinX(inHdc,(int)xa,(int)x1,(int)ya);
		LinX(inHdc,(int)x2,(int)xe,(int)ye);
	}
	else				// vertical
	{	
		double x1,x2,y1,y2;

		if(xa<xe)
			{ x1=ceil(xa);x2=floor(xe);	}
		  else
			{ x1=floor(xa);x2=ceil(xe); }

		if(ABS(dx)>0.0000001)
		{
			double m=dy/dx;

			y1=ya+m*(x1-xa);
			y2=ya+m*(x2-xa);
		
			y1=bound_in(y1,ya,ye);
			y2=bound_in(y2,ya,ye);
		}
		else 
		{ y1=ye;y2=ya;}

		double from=y1;
		double step=(y2-from)/(x2-x1);

		if(xa<xe)
		{
			for(int x=(int)x1;x<(int)x2;x++,from+=step)
				LinY(inHdc,(int)from,(int)(from+step),(int)x);
		}
		else
		{
			for(int x=(int)x1-1;x>=(int)x2;x--,from-=step)
				LinY(inHdc,(int)from,(int)(from-step),(int)x);
		}

		LinY(inHdc,(int)ya,(int)y1,(int)xa);
		LinY(inHdc,(int)y2,(int)ye,(int)xe);
	}
}





















int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
 	// TODO: Place code here.
	MSG msg;
	HACCEL hAccelTable;

	// Initialize global strings
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_SUBPIXELLINE, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow)) 
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, (LPCTSTR)IDC_SUBPIXELLINE);

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) 
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return msg.wParam;
}



//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    This function and its usage is only necessary if you want this code
//    to be compatible with Win32 systems prior to the 'RegisterClassEx'
//    function that was added to Windows 95. It is important to call this function
//    so that the application will get 'well formed' small icons associated
//    with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX); 

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= (WNDPROC)WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, (LPCTSTR)IDI_SUBPIXELLINE);
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= (LPCSTR)IDC_SUBPIXELLINE;
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, (LPCTSTR)IDI_SMALL);

	return RegisterClassEx(&wcex);
}

//
//   FUNCTION: InitInstance(HANDLE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   HWND hWnd;

   hInst = hInstance; // Store instance handle in our global variable

   hWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPEDWINDOW,
      CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInstance, NULL);

   if (!hWnd)
   {
      return FALSE;
   }

   ShowWindow(hWnd, nCmdShow);
   UpdateWindow(hWnd);

   return TRUE;
}

//
//  FUNCTION: WndProc(HWND, unsigned, WORD, LONG)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	HDC hdc;
	TCHAR szHello[MAX_LOADSTRING];
	LoadString(hInst, IDS_HELLO, szHello, MAX_LOADSTRING);

	switch (message) 
	{
		case WM_COMMAND:
			wmId    = LOWORD(wParam); 
			wmEvent = HIWORD(wParam); 
			// Parse the menu selections:
			switch (wmId)
			{
				case IDM_EXIT:
				   DestroyWindow(hWnd);
				   break;
				default:
				   return DefWindowProc(hWnd, message, wParam, lParam);
			}
			break;
		case WM_PAINT:
			hdc = BeginPaint(hWnd, &ps);

			RECT rt;
			GetClientRect(hWnd, &rt);

			{
				float f;

				for(f=0.0f;f<2.0f*3.14159265f;f+=2.0f*3.14159265f/180.0f)
				{
					float midx=(rt.left+rt.right)*0.5f;
					float midy=(rt.top+rt.bottom)*0.5f;

					float rx=(float)(sin(f)*(rt.right-rt.left)*0.5f);
					float ry=(float)(cos(f)*(rt.bottom-rt.top)*0.5f);

					SubPixelLine(hdc,midx+rx*0.3f,midy+ry*0.3f,midx+rx*0.7f,midy+ry*0.7f);
				}
				SubPixelLine(hdc,10,10,100,10);
				SubPixelLine(hdc,10,10,10,100);
				SubPixelLine(hdc,5,5,5,5);
				SubPixelLine(hdc,15,5.2f,15,5);
				SubPixelLine(hdc,15,15,55,55);
				SubPixelLine(hdc,25,15,85,15.98f);

				for(f=0;f<2.0f;f+=0.1f)
					SubPixelLine(hdc,25,65+f*100.0f,85,65+f*101.0f);
			}

			EndPaint(hWnd, &ps);
			break;
		case WM_DESTROY:
			PostQuitMessage(0);
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
   }
   return 0;
}

